import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.util.HashSet;
import java.util.Collections;

public class Demo {

    public static void main(String[] args) {
        
        Set<Person> people = new HashSet<>();
        
        people.add(new Person("Igor"));
        people.add(new Person("Pavel"));
        people.add(new Person("Ivan"));
        people.add(new Person("Igor"));
                
        for(Person p: people) {
            System.out.println(p);
        }
    }
}
class Person {
    private String name;
    public Person(String name) { this.name = name; }
    public String toString() { return "Person "+name; }
    
    @Override
    public boolean equals(Object o) {
        if(o instanceof Person) {
            Person p = (Person)o;
            return this.name.equals(p.name);
        } else return false;
    }
    
    @Override
    public int hashCode() {
        return name.hashCode();
    }
}